/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.41 Revision 1.49
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.41 2006/05/19 19:24:21 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.49 2008/02/22 09:33:45 hollow Exp $
4# 4#
5# eclass/webapp.eclass 5# @ECLASS: webapp.eclass
6# @MAINTAINER:
7# web-apps@gentoo.org
6# Eclass for installing applications to run under a web server 8# @BLURB: functions for installing applications to run under a web server
7# 9# @DESCRIPTION:
10# The webapp eclass contains functions to handle web applications with
8# Part of the implementation of GLEP #11 11# webapp-config. Part of the implementation of GLEP #11
9#
10# Author(s) Stuart Herbert <stuart@gentoo.org>
11# Renat Lumpau <rl03@gentoo.org>
12# Gunnar Wrobel <wrobel@gentoo.org>
13#
14# ------------------------------------------------------------------------
15#
16# The master copy of this eclass is held in our subversion repository.
17# http://svn.gnqs.org/projects/vhost-tools/browser/
18#
19# If you make changes to this file and don't tell us, chances are that
20# your changes will be overwritten the next time we release a new version
21# of webapp-config.
22#
23# ------------------------------------------------------------------------
24 12
25SLOT="${PVR}" 13SLOT="${PVR}"
26IUSE="vhosts" 14IUSE="vhosts"
27DEPEND="app-admin/webapp-config" 15DEPEND=">=app-admin/webapp-config-1.50.15"
28RDEPEND="${DEPEND}" 16RDEPEND="${DEPEND}"
29 17
30EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 18EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
31 19
32INSTALL_DIR="/${PN}" 20INSTALL_DIR="/${PN}"
35 23
36INSTALL_CHECK_FILE="installed_by_webapp_eclass" 24INSTALL_CHECK_FILE="installed_by_webapp_eclass"
37 25
38ETC_CONFIG="${ROOT}/etc/vhosts/webapp-config" 26ETC_CONFIG="${ROOT}/etc/vhosts/webapp-config"
39WEBAPP_CONFIG="${ROOT}/usr/sbin/webapp-config" 27WEBAPP_CONFIG="${ROOT}/usr/sbin/webapp-config"
28WEBAPP_CLEANER="${ROOT}/usr/sbin/webapp-cleaner"
40 29
41# ------------------------------------------------------------------------ 30# ==============================================================================
42# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 31# INTERNAL FUNCTIONS
43# 32# ==============================================================================
33
44# Load the config file /etc/vhosts/webapp-config 34# Load the config file /etc/vhosts/webapp-config
45#
46# Supports both the old bash version, and the new python version 35# Supports both the old bash version, and the new python version
47#
48# ------------------------------------------------------------------------
49
50function webapp_read_config () 36webapp_read_config() {
51{
52 if has_version '>=app-admin/webapp-config-1.50'; then 37 if has_version '>=app-admin/webapp-config-1.50'; then
53 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!" 38 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
54 eval ${ENVVAR} 39 eval ${ENVVAR}
55 else 40 else
56 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}" 41 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
57 fi 42 fi
58} 43}
59 44
60# ------------------------------------------------------------------------
61# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
62#
63# Check whether a specified file exists within the image/ directory 45# Check whether a specified file exists in the given directory (`.' by default)
64# or not. 46# or not.
65#
66# @param $1 - file to look for
67# @param $2 - prefix directory to use
68# @return 0 on success, never returns on an error
69# ------------------------------------------------------------------------
70
71function webapp_checkfileexists () 47webapp_checkfileexists() {
72{
73 local my_prefix 48 local my_prefix
74 49
75 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix= 50 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix=
76 51
77 if [ ! -e "${my_prefix}${1}" ]; then 52 if [ ! -e "${my_prefix}${1}" ]; then
80 eerror "Please report this as a bug at http://bugs.gentoo.org/" 55 eerror "Please report this as a bug at http://bugs.gentoo.org/"
81 die "$msg" 56 die "$msg"
82 fi 57 fi
83} 58}
84 59
85# ------------------------------------------------------------------------
86# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
87# ------------------------------------------------------------------------
88
89function webapp_check_installedat 60webapp_check_installedat() {
90{
91 local my_output
92
93 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null 61 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
94} 62}
95 63
96# ------------------------------------------------------------------------
97# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
98#
99# ------------------------------------------------------------------------
100
101function webapp_strip_appdir () 64webapp_strip_appdir() {
102{
103 local my_stripped="${1}" 65 local my_stripped="${1}"
104 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;" 66 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;"
105} 67}
106 68
107function webapp_strip_d () 69webapp_strip_d() {
108{
109 echo "${1}" | sed -e "s|${D}||g;" 70 echo "${1}" | sed -e "s|${D}||g;"
110} 71}
111 72
112function webapp_strip_cwd () 73webapp_strip_cwd() {
113{
114 local my_stripped="${1}" 74 local my_stripped="${1}"
115 echo "${1}" | sed -e 's|/./|/|g;' 75 echo "${1}" | sed -e 's|/./|/|g;'
116} 76}
117 77
118# ------------------------------------------------------------------------ 78# ==============================================================================
119# EXPORTED FUNCTION - FOR USE IN EBUILDS 79# PUBLIC FUNCTIONS
120# 80# ==============================================================================
121# Identify a config file for a web-based application.
122#
123# @param $1 - config file
124# ------------------------------------------------------------------------
125 81
82# @FUNCTION: webapp_configfile
83# @USAGE: <file> [more files ...]
84# @DESCRIPTION:
85# Mark a file config-protected for a web-based application.
126function webapp_configfile () 86webapp_configfile() {
127{
128 local m="" 87 local m=""
129 for m in "$@" ; do 88 for m in "$@" ; do
130 webapp_checkfileexists "${m}" "${D}" 89 webapp_checkfileexists "${m}" "${D}"
131 90
132 local MY_FILE="$(webapp_strip_appdir "${m}")" 91 local MY_FILE="$(webapp_strip_appdir "${m}")"
133 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 92 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
134 93
135 einfo "(config) ${MY_FILE}" 94 elog "(config) ${MY_FILE}"
136 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST} 95 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST}
137 done 96 done
138} 97}
139 98
140# ------------------------------------------------------------------------ 99# @FUNCTION: webapp_hook_script
141# EXPORTED FUNCTION - FOR USE IN EBUILDS 100# @USAGE: <file>
142# 101# @DESCRIPTION:
143# Install a script that will run after a virtual copy is created, and 102# Install a script that will run after a virtual copy is created, and
144# before a virtual copy has been removed 103# before a virtual copy has been removed.
145#
146# @param $1 - the script to run
147# ------------------------------------------------------------------------
148
149function webapp_hook_script () 104webapp_hook_script() {
150{
151 webapp_checkfileexists "${1}" 105 webapp_checkfileexists "${1}"
152 106
153 einfo "(hook) ${1}" 107 elog "(hook) ${1}"
154 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/" 108 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
155 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" 109 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
156} 110}
157 111
158# ------------------------------------------------------------------------ 112# @FUNCTION: webapp_postinst_txt
159# EXPORTED FUNCTION - FOR USE IN EBUILDS 113# @USAGE: <lang> <file>
160# 114# @DESCRIPTION:
161# Install a text file containing post-installation instructions. 115# Install a text file containing post-installation instructions.
162#
163# @param $1 - language code (use 'en' for now)
164# @param $2 - the file to install
165# ------------------------------------------------------------------------
166
167function webapp_postinst_txt () 116webapp_postinst_txt() {
168{
169 webapp_checkfileexists "${2}" 117 webapp_checkfileexists "${2}"
170 118
171 einfo "(info) ${2} (lang: ${1})" 119 elog "(info) ${2} (lang: ${1})"
172 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt" 120 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
173} 121}
174 122
175# ------------------------------------------------------------------------ 123# @FUNCTION: webapp_postupgrade_txt
176# EXPORTED FUNCTION - FOR USE IN EBUILDS 124# @USAGE: <lang> <file>
177# 125# @DESCRIPTION:
178# Install a text file containing post-upgrade instructions. 126# Install a text file containing post-upgrade instructions.
179#
180# @param $1 - language code (use 'en' for now)
181# @param $2 - the file to install
182# ------------------------------------------------------------------------
183
184function webapp_postupgrade_txt () 127webapp_postupgrade_txt() {
185{
186 webapp_checkfileexists "${2}" 128 webapp_checkfileexists "${2}"
187 129
188 einfo "(info) ${2} (lang: ${1})" 130 elog "(info) ${2} (lang: ${1})"
189 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt" 131 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
190} 132}
191 133
192# ------------------------------------------------------------------------ 134# @FUNCTION: webapp_serverowned
193# EXPORTED FUNCTION - FOR USE IN EBUILDS 135# @USAGE: [-R] <file> [more files ...]
194# 136# @DESCRIPTION:
195# Identify a file which must be owned by the webserver's user:group 137# Identify a file which must be owned by the webserver's user:group settings.
196# settings.
197#
198# The ownership of the file is NOT set until the application is installed 138# The ownership of the file is NOT set until the application is installed using
199# using the webapp-config tool. 139# the webapp-config tool. If -R is given directories are handled recursively.
200#
201# @param $1 - file to be owned by the webserver user:group combo
202#
203# ------------------------------------------------------------------------
204
205function webapp_serverowned () 140webapp_serverowned() {
206{
207 local a="" 141 local a=""
208 local m="" 142 local m=""
209 if [ "${1}" = "-R" ]; then 143 if [ "${1}" = "-R" ]; then
210 shift 144 shift
211 for m in "$@" ; do 145 for m in "$@" ; do
213 a=${a/${D}\/\///} 147 a=${a/${D}\/\///}
214 webapp_checkfileexists "${a}" "$D" 148 webapp_checkfileexists "${a}" "$D"
215 local MY_FILE="$(webapp_strip_appdir "${a}")" 149 local MY_FILE="$(webapp_strip_appdir "${a}")"
216 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 150 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
217 151
218 einfo "(server owned) ${MY_FILE}" 152 elog "(server owned) ${MY_FILE}"
219 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}" 153 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
220 done 154 done
221 done 155 done
222 else 156 else
223 for m in "$@" ; do 157 for m in "$@" ; do
224 webapp_checkfileexists "${m}" "$D" 158 webapp_checkfileexists "${m}" "$D"
225 local MY_FILE="$(webapp_strip_appdir "${m}")" 159 local MY_FILE="$(webapp_strip_appdir "${m}")"
226 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 160 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
227 161
228 einfo "(server owned) ${MY_FILE}" 162 elog "(server owned) ${MY_FILE}"
229 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}" 163 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
230 done 164 done
231 fi 165 fi
232} 166}
233 167
234# ------------------------------------------------------------------------ 168# @FUNCTION: webapp_server_configfile
235# EXPORTED FUNCTION - FOR USE IN EBUILDS 169# @USAGE: <server> <file> [new name]
236# 170# @DESCRIPTION:
237# @param $1 - the webserver to install the config file for 171# Install a configuration file for the webserver. You need to specify a
238# (one of apache1, apache2, cherokee) 172# webapp-config supported <server>. if no new name is given `basename $2' is
239# @param $2 - the config file to install 173# used by default. Note: this function will automagically prepend $1 to the
240# @param $3 - new name for the config file (default is `basename $2`) 174# front of your config file's name.
241# this is an optional parameter
242#
243# NOTE:
244# this function will automagically prepend $1 to the front of your
245# config file's name
246# ------------------------------------------------------------------------
247
248function webapp_server_configfile () 175webapp_server_configfile() {
249{
250 webapp_checkfileexists "${2}" 176 webapp_checkfileexists "${2}"
251 177
252 # sort out what the name will be of the config file 178 # sort out what the name will be of the config file
253 179
254 local my_file 180 local my_file
262 # warning: 188 # warning:
263 # 189 #
264 # do NOT change the naming convention used here without changing all 190 # do NOT change the naming convention used here without changing all
265 # the other scripts that also rely upon these names 191 # the other scripts that also rely upon these names
266 192
267 einfo "(${1}) config file '${my_file}'" 193 elog "(${1}) config file '${my_file}'"
268 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}" 194 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
269} 195}
270 196
271# ------------------------------------------------------------------------ 197# @FUNCTION: webapp_sqlscript
272# EXPORTED FUNCTION - FOR USE IN EBUILDS 198# @USAGE: <db> <file> [version]
273# 199# @DESCRIPTION:
274# @param $1 - the db engine that the script is for 200# Install a SQL script that creates/upgrades a database schema for the web
275# (one of: mysql|postgres) 201# application. Currently supported database engines are mysql and postgres.
276# @param $2 - the sql script to be installed 202# If a version is given the script should upgrade the database schema from
277# @param $3 - the older version of the app that this db script 203# the given version to $PVR.
278# will upgrade from
279# (do not pass this option if your SQL script only creates
280# a new db from scratch)
281# ------------------------------------------------------------------------
282
283function webapp_sqlscript () 204webapp_sqlscript() {
284{
285 webapp_checkfileexists "${2}" 205 webapp_checkfileexists "${2}"
286 206
287 # create the directory where this script will go 207 # create the directory where this script will go
288 # 208 #
289 # scripts for specific database engines go into their own subdirectory 209 # scripts for specific database engines go into their own subdirectory
299 # the other scripts that also rely upon these names 219 # the other scripts that also rely upon these names
300 220
301 # are we dealing with an 'upgrade'-type script? 221 # are we dealing with an 'upgrade'-type script?
302 if [ -n "${3}" ]; then 222 if [ -n "${3}" ]; then
303 # yes we are 223 # yes we are
304 einfo "(${1}) upgrade script from ${PN}-${PVR} to ${3}" 224 elog "(${1}) upgrade script from ${PN}-${PVR} to ${3}"
305 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 225 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
306 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 226 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
307 else 227 else
308 # no, we are not 228 # no, we are not
309 einfo "(${1}) create script for ${PN}-${PVR}" 229 elog "(${1}) create script for ${PN}-${PVR}"
310 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 230 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
311 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 231 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
312 fi 232 fi
313} 233}
314 234
315# ------------------------------------------------------------------------ 235# ==============================================================================
316# EXPORTED FUNCTION - call from inside your ebuild's src_install AFTER 236# EXPORTED FUNCTIONS
317# everything else has run 237# ==============================================================================
318# 238
239# @FUNCTION: webapp_src_install
240# @DESCRIPTION:
241# You need to call this function in src_install() AFTER everything else has run.
319# For now, we just make sure that root owns everything, and that there 242# For now, we just make sure that root owns everything, and that there are no
320# are no setuid files. 243# setuid files.
321# ------------------------------------------------------------------------
322
323function webapp_src_install () 244webapp_src_install() {
324{
325 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/" 245 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
326 chmod -R u-s "${D}/" 246 chmod -R u-s "${D}/"
327 chmod -R g-s "${D}/" 247 chmod -R g-s "${D}/"
328 248
329 keepdir "${MY_PERSISTDIR}" 249 keepdir "${MY_PERSISTDIR}"
338 # webapp_pkg_postinst() within the same shell process 258 # webapp_pkg_postinst() within the same shell process
339 259
340 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}" 260 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
341} 261}
342 262
343# ------------------------------------------------------------------------ 263# @FUNCTION: webapp_pkg_setup
344# EXPORTED FUNCTION - call from inside your ebuild's pkg_config AFTER 264# @DESCRIPTION:
345# everything else has run 265# You need to call this function in pkg_config() AFTER everything else has run.
346#
347# If 'vhosts' USE flag is not set, auto-install this app 266# If 'vhosts' USE flag is not set, auto-install this app.
348#
349# ------------------------------------------------------------------------
350
351function webapp_pkg_setup () 267webapp_pkg_setup() {
352{
353 # add sanity checks here 268 # add sanity checks here
354 269
355 if [ "${SLOT}+" != "${PVR}+" ]; then
356 # special case - some ebuilds *do* need to overwride the SLOT 270 # special case - some ebuilds *do* need to overwride the SLOT
357 if [ "${WEBAPP_MANUAL_SLOT}" != "yes" ]; then 271 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
358 die "ebuild sets SLOT, overrides webapp.eclass" 272 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
359 else
360 ewarn
361 ewarn "This ebuild overrides the default SLOT behaviour for webapps"
362 ewarn "If this package installs files into the htdocs dir, this is"
363 ewarn "probably a bug in the ebuild."
364 ewarn
365 fi
366 fi 273 fi
367 274
368 # pull in the shared configuration file 275 # pull in the shared configuration file
369 276
370 G_HOSTNAME="localhost" 277 G_HOSTNAME="localhost"
376 if ! use vhosts ; then 283 if ! use vhosts ; then
377 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}" 284 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
378 local my_output 285 local my_output
379 286
380 if [ -d "${my_dir}" ] ; then 287 if [ -d "${my_dir}" ] ; then
381 einfo "You already have something installed in ${my_dir}"
382 einfo "Are you trying to install over the top of something I cannot upgrade?"
383
384 my_output="$(webapp_check_installedat)" 288 my_output="$(webapp_check_installedat)"
385 289
386 if [ "$?" != "0" ]; then 290 if [ "$?" != "0" ]; then
387
388 # okay, whatever is there, it isn't webapp-config-compatible 291 # okay, whatever is there, it isn't webapp-config-compatible
292 ewarn "You already have something installed in ${my_dir}"
389 ewarn 293 ewarn
390 ewarn "Whatever is in ${my_dir}, it's not" 294 ewarn "Whatever is in ${my_dir}, it's not"
391 ewarn "compatible with webapp-config." 295 ewarn "compatible with webapp-config."
392 ewarn 296 ewarn
393 ewarn "This ebuild may be overwriting important files." 297 ewarn "This ebuild may be overwriting important files."
394 ewarn 298 ewarn
395 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then 299 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then
396 eerror "${my_dir} contains ${my_output}" 300 eerror "${my_dir} contains ${my_output}"
397 eerror "I cannot upgrade that" 301 eerror "I cannot upgrade that"
398 die "Cannot upgrade contents of ${my_dir}" 302 die "Cannot upgrade contents of ${my_dir}"
399 else
400 einfo
401 einfo "I can upgrade the contents of ${my_dir}"
402 einfo
403 fi 303 fi
404 fi 304 fi
405 fi 305 fi
406} 306}
407 307
408function webapp_getinstalltype () 308webapp_getinstalltype() {
409{
410 # or are we upgrading? 309 # or are we upgrading?
411 310
412 if ! use vhosts ; then 311 if ! use vhosts ; then
413 # we only run webapp-config if vhosts USE flag is not set 312 # we only run webapp-config if vhosts USE flag is not set
414 313
426 325
427 REMOVE_PKG="${my_pn}-${my_pvr}" 326 REMOVE_PKG="${my_pn}-${my_pvr}"
428 327
429 if [ "${my_pn}" == "${PN}" ]; then 328 if [ "${my_pn}" == "${PN}" ]; then
430 if [ "${my_pvr}" != "${PVR}" ]; then 329 if [ "${my_pvr}" != "${PVR}" ]; then
431 einfo "This is an upgrade" 330 elog "This is an upgrade"
432 IS_UPGRADE=1 331 IS_UPGRADE=1
433 else 332 else
434 einfo "This is a re-installation" 333 elog "This is a re-installation"
435 IS_REPLACE=1 334 IS_REPLACE=1
436 fi 335 fi
437 else 336 else
438 einfo "${my_output} is installed there" 337 elog "${my_output} is installed there"
439 fi 338 fi
440 else 339 else
441 einfo "This is an installation" 340 elog "This is an installation"
442 fi 341 fi
443 fi 342 fi
444} 343}
445 344
446function webapp_src_preinst () 345webapp_src_preinst() {
447{
448 # create the directories that we need 346 # create the directories that we need
449 347
450 dodir "${MY_HTDOCSDIR}" 348 dodir "${MY_HTDOCSDIR}"
451 dodir "${MY_HOSTROOTDIR}" 349 dodir "${MY_HOSTROOTDIR}"
452 dodir "${MY_CGIBINDIR}" 350 dodir "${MY_CGIBINDIR}"
455 dodir "${MY_SQLSCRIPTSDIR}" 353 dodir "${MY_SQLSCRIPTSDIR}"
456 dodir "${MY_HOOKSCRIPTSDIR}" 354 dodir "${MY_HOOKSCRIPTSDIR}"
457 dodir "${MY_SERVERCONFIGDIR}" 355 dodir "${MY_SERVERCONFIGDIR}"
458} 356}
459 357
460function webapp_pkg_postinst () 358webapp_pkg_postinst() {
461{
462 webapp_read_config 359 webapp_read_config
463 360
464 # sanity checks, to catch bugs in the ebuild 361 # sanity checks, to catch bugs in the ebuild
465 362
466 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then 363 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then
479 # if 'vhosts' is not set in your USE flags, we install a copy of 376 # if 'vhosts' is not set in your USE flags, we install a copy of
480 # this application in ${ROOT}/var/www/localhost/htdocs/${PN}/ for you 377 # this application in ${ROOT}/var/www/localhost/htdocs/${PN}/ for you
481 378
482 if ! use vhosts ; then 379 if ! use vhosts ; then
483 echo 380 echo
484 einfo "vhosts USE flag not set - auto-installing using webapp-config" 381 elog "vhosts USE flag not set - auto-installing using webapp-config"
485 382
486 webapp_getinstalltype 383 webapp_getinstalltype
487 384
488 G_HOSTNAME="localhost" 385 G_HOSTNAME="localhost"
489 local my_mode=-I 386 local my_mode=-I
490 webapp_read_config 387 webapp_read_config
491 388
492 if [ "${IS_REPLACE}" = "1" ]; then 389 if [ "${IS_REPLACE}" = "1" ]; then
493 einfo "${PN}-${PVR} is already installed - replacing" 390 elog "${PN}-${PVR} is already installed - replacing"
494 my_mode=-I 391 my_mode=-I
495 elif [ "${IS_UPGRADE}" = "1" ]; then 392 elif [ "${IS_UPGRADE}" = "1" ]; then
496 einfo "${REMOVE_PKG} is already installed - upgrading" 393 elog "${REMOVE_PKG} is already installed - upgrading"
497 my_mode=-U 394 my_mode=-U
498 else 395 else
499 einfo "${PN}-${PVR} is not installed - using install mode" 396 elog "${PN}-${PVR} is not installed - using install mode"
500 fi 397 fi
501 398
502 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}" 399 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
503 einfo "Running ${my_cmd}" 400 elog "Running ${my_cmd}"
504 ${my_cmd} 401 ${my_cmd}
505 402
506 # remove the old version 403 # run webapp-cleaner instead of emerge
507 # 404 echo
508 # why do we do this? well ... 405 local cleaner="${WEBAPP_CLEANER} -p -C ${PN}"
509 # 406 einfo "Running ${cleaner}"
510 # normally, emerge -u installs a new version and then removes the 407 ${cleaner}
511 # old version. however, if the new version goes into a different
512 # slot to the old version, then the old version gets left behind
513 #
514 # if USE=-vhosts, then we want to remove the old version, because
515 # the user is relying on portage to do the magical thing for it
516
517 if [ "${IS_UPGRADE}" = "1" ] ; then
518 einfo "Removing old version ${REMOVE_PKG}"
519
520 emerge -C "${REMOVE_PKG}"
521 fi
522 else 408 else
523 # vhosts flag is on 409 # vhosts flag is on
524 # 410 #
525 # let's tell the administrator what to do next 411 # let's tell the administrator what to do next
526 412
527 einfo 413 elog
528 einfo "The 'vhosts' USE flag is switched ON" 414 elog "The 'vhosts' USE flag is switched ON"
529 einfo "This means that Portage will not automatically run webapp-config to" 415 elog "This means that Portage will not automatically run webapp-config to"
530 einfo "complete the installation." 416 elog "complete the installation."
531 einfo 417 elog
532 einfo "To install ${PN}-${PVR} into a virtual host, run the following command:" 418 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
533 einfo 419 elog
534 einfo " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}" 420 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
535 einfo 421 elog
536 einfo "For more details, see the webapp-config(8) man page" 422 elog "For more details, see the webapp-config(8) man page"
537 fi 423 fi
538 424
539 return 0 425 return 0
540} 426}
541 427
542function webapp_pkg_prerm () 428webapp_pkg_prerm() {
543{
544 # remove any virtual installs that there are 429 # remove any virtual installs that there are
545 430
546 local my_output 431 local my_output
547 local x 432 local x
548 433
550 435
551 if [ "${?}" != "0" ]; then 436 if [ "${?}" != "0" ]; then
552 return 437 return
553 fi 438 fi
554 439
440 if ! use vhosts ; then # remove any installed copies
441
555 for x in ${my_output} ; do 442 for x in ${my_output} ; do
556 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp" 443 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
557
558 if [ -z "${WEB_HOSTNAME}" -o -z "${WEB_INSTALLDIR}" ]; then 444 if [ "${WEB_HOSTNAME}" -a "${WEB_INSTALLDIR}" ]; then
445 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
446 fi
447 done
448 else # don't remove anything, but warn user. bug #136959
449
559 ewarn "Don't forget to use webapp-config to remove the copy of" 450 ewarn "Don't forget to use webapp-config to remove any copies of"
560 ewarn "${PN}-${PVR} installed in" 451 ewarn "${PN}-${PVR} installed in"
561 ewarn 452 ewarn
453
454 for x in ${my_output} ; do
455 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
562 ewarn " ${x}" 456 ewarn " ${x}"
563 ewarn
564 else
565 # we have enough information to remove the virtual copy ourself
566
567 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
568
569 # if the removal fails - we carry on anyway!
570 fi
571 done 457 done
458 fi
572} 459}

Legend:
Removed from v.1.41  
changed lines
  Added in v.1.49

  ViewVC Help
Powered by ViewVC 1.1.20